///////////////////////////////////////////////////////////////////////////////
//
//  Filename: BahnDesign.h
//  Author: Wang, Yi
//  Last modified: 2004-2-24 14:30
//
///////////////////////////////////////////////////////////////////////////////

#ifndef BahnDesignH
#define BahnDesignH

#include "BCommon.h"
#include "CtlPointList.h"
#include "SpeedList.h"

#define MaxBahnDesignPtCount 1000

enum enCrossMode {CM_Easy, CM_P1_fault, CM_P2_fault, CM_both_fault};

class BahnDesign
{
public:
    int Count; // count of BahnDesignPts
    int StkCt; // count of BahnStrecke
	tagCalcGeoIContext gc; // context
	tagBahnDesignPt Pts[MaxBahnDesignPtCount];
    tagBahnStrecke Stks[MaxBahnDesignPtCount*4];
    CtlPointList CtlPtList;
    SpeedList SpdList;	//SpeedList

	tagBahnDesignPt* add();
    BahnDesign(void);
    ~BahnDesign(void);
    tagBahnDesignPt * insert(int id);
    void remove(int id);
    void Calc(void);
    int SearchBDPt(double x, double y, double r, double tArrowLen, bool IsSearchArrow);
private:
	void CalcSpeed(void);
    void CalcGeo(void);
    void CalcGeoI(tagCalcGeoIContext &gc);
	void CalcGeoI_far(tagCalcGeoIContext &gc);
	bool CheckDistance(tagCalcGeoIContext &gc);
};

#endif
