///////////////////////////////////////////////////////////////////////////////
//
//  Filename: Track.h
//  Author: Wang, Yi
//  Last modified: 2004-2-25 3:54
//
///////////////////////////////////////////////////////////////////////////////

#ifndef TrackH
#define TrackH

#include "BCommon.h"
#include <qvaluevector.h>
#include <qstring.h>
#include <math.h>

class Track
{
public:
	Track(void);
	void AppendCmd(QString &cmd);
	void Reset(void);
	void Reset(tagPos & pos);
	tagPos &Item(int index);
	int GetCount(void);
    tagPos CurPos;
private:	
	void Step(int time, int l, int r);

	QValueVector<tagPos> vec;
	double AchseLen;
	double StepLen;
	double Grid;
    double Omega;
    tagPos OldPos, ResetPos;
    int lk0; 
};

#endif
